#!/bin/csh
#SBATCH --ntasks=1
#SBATCH -N 1
#SBATCH --job-name=rdf-pc-pe
#SBATCH -t 01:00:00
#

unset noclobber

# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR

hostname

# loop over all equilibrated dyn in trajectory
set k = $1
while ($k <= $2)
# use the ones below if calculating rdf between Ps from same headgroups
# rdf-p-2d.exe < ../inp/inp$k
# uncomment below if calculating rdf between Ps from different headgroups
rdf-oo-2d.exe < inp/inp$k
@ k = $k + 1
end

# get average between top and bottom leaflet
# avg.csh (first dcd) (last dcd)
# gets variables from submission, rdf.scr
avg.csh $1 $2

# combine all averaged files into one
# combine.csh (leader) (last file #) (start count)
# UPDATE last number to the file where equilibrated trajectory starts
combine.csh avg-rdf-p $2 $3

# average equilibrated trajectory data to have a single g(r)
# full.csh (name to copy file)
full.csh 
