/* This Program Calculates OO RDF in 2-dimensions between differnent lipids */
/* Created by: Dr. Jeff Klauda                                       */
/* Date: 09/20/2004                                                  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE *main_inp;
FILE *main_inp2;
FILE *main_inp3;
FILE *main_out;
FILE *main_out2;

#define MAX_R 50000
#define MAX_PART 400
#define N_SAMP 8
#define PI 3.14159

double (*xp)[MAX_R]=new double[MAX_PART][MAX_R];
double (*yp)[MAX_R]=new double[MAX_PART][MAX_R];
double (*zp)[MAX_R]=new double[MAX_PART][MAX_R];
double (*xp2)[MAX_R]=new double[MAX_PART][MAX_R];
double (*yp2)[MAX_R]=new double[MAX_PART][MAX_R];
double (*zp2)[MAX_R]=new double[MAX_PART][MAX_R];

double line_res[4];

int main(void)
{
    char input[80],output[80],input2[80],input3[80];
    double boxl[MAX_R],maxr,rmin,rmax,dens[500],dens2[500],r2;
    double ri[8],dens_bulk;
    int i,j,k,m,n,t,ntot,ndr,num_mol,num_mol2;

    for(i=0;i<500;i++)
    {
        dens[i]=0;
        dens2[i]=0;
    }

    printf("\n\nXYZ Data File for atom1: ");
    scanf("%s",&input);
    main_inp = fopen (input,"r");

    printf("\n\nXYZ Data File for atom2: ");
    scanf("%s",&input3);
    main_inp3 = fopen (input3,"r");

    printf("\n\nBox Length File: ");
    scanf("%s",&input2);
    main_inp2 = fopen (input2,"r");

    printf("\n\nOutput L1 File: ");
    scanf("%s",&output);
    main_out = fopen (output,"w");

    printf("\n\nmax-gr #-of-dr: ");
    scanf("%lf%d",&maxr,&ndr);

    fscanf(main_inp,"%d%d",&ntot,&num_mol);
    fscanf(main_inp3,"%d%d",&ntot,&num_mol2);

    for(i=0;i<ntot;i++)
    {
        for(j=0;j<num_mol;j++)
        {
            fscanf(main_inp,"%d%lf%lf%lf",&t,&xp[j][i],&yp[j][i],&zp[j][i]);
        }
        for(j=0;j<num_mol2;j++)
        {
            fscanf(main_inp3,"%d%lf%lf%lf",&t,&xp2[j][i],&yp2[j][i],&zp2[j][i]);
        }
	fscanf(main_inp2,"%lf",&boxl[i]);
    }

// Determine the O,O G(r) (normalized)

    for(i=0;i<ntot;i++)
    {
        for(j=0;j<num_mol/2;j++)                                // Leaflet 1
        {
            for(k=0;k<num_mol2/2;k++)      
            {
                r2 = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[0] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[1] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[2] = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[3] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[4] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[5] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);
                ri[6] = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);
                ri[7] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);

                dens_bulk=((num_mol2)/2)/(boxl[i]*boxl[i]);
                for(m=0;m<ndr;m++)
                {
                    rmin=m*maxr/ndr;
                    rmax=(m+1)*maxr/ndr;
                    if(r2<=rmax*rmax && r2>rmin*rmin)           // Count density
                        dens[m]=dens[m]+1.0/ntot/(num_mol/2)/(PI*(rmax*rmax-rmin*rmin))/dens_bulk;
                    for(n=0;n<8;n++)
                        if(ri[n]<=rmax*rmax && ri[n]>rmin*rmin)
                           dens[m]=dens[m]+1.0/ntot/(num_mol/2)/(PI*(rmax*rmax-rmin*rmin))/dens_bulk;
                }
            }
        }

        for(j=num_mol/2;j<num_mol;j++)                                // Leaflet 2
        {
            for(k=num_mol2/2;k<num_mol2;k++)
            {
                r2 = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[0] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[1] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[2] = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[3] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i]-boxl[i])*(yp[j][i]-yp2[k][i]-boxl[i]);
                ri[4] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i])*(yp[j][i]-yp2[k][i]);
                ri[5] = (xp[j][i]-xp2[k][i]-boxl[i])*(xp[j][i]-xp2[k][i]-boxl[i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);
                ri[6] = (xp[j][i]-xp2[k][i])*(xp[j][i]-xp2[k][i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);
                ri[7] = (xp[j][i]-xp2[k][i]+boxl[i])*(xp[j][i]-xp2[k][i]+boxl[i])+
                        (yp[j][i]-yp2[k][i]+boxl[i])*(yp[j][i]-yp2[k][i]+boxl[i]);

                for(m=0;m<ndr;m++)
                {
                    rmin=m*maxr/ndr;
                    rmax=(m+1)*maxr/ndr;
                    if(r2<=rmax*rmax && r2>rmin*rmin)           // Count density
                        dens2[m]=dens2[m]+1.0/ntot/(num_mol/2)/(PI*(rmax*rmax-rmin*rmin))/dens_bulk;
                    for(n=0;n<8;n++)
                        if(ri[n]<=rmax*rmax && ri[n]>rmin*rmin)
                           dens2[m]=dens2[m]+1.0/ntot/(num_mol/2)/(PI*(rmax*rmax-rmin*rmin))/dens_bulk;
                }
            }
        }
    }

// Print out results

    for(i=0;i<ndr;i++)
    {
        fprintf(main_out,"%1.2lf\t%1.5lf\t%1.5lf\n",(i+1)*maxr/ndr,dens[i],dens2[i]);
    }

}

