#!/bin/csh
#SBATCH --ntasks=1
#SBATCH -N 1
#SBATCH --job-name=coor-sterol
#SBATCH -t 02:00:00
#SBATCH --constraint="[ib|qib]"

# coord.csh (first dcd) (last dcd)
# specify numbers in the submission script

unset noclobber
# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR

module load openmpi/1.6
module load fftw/3.3.3/gnu/4.6.1/openmpi/1.6/shared
setenv LD_LIBRARY_PATH $FFTWLIB 
# XZ: Turn off the mpi warning as infiniband is being used with the OFED verbs driver.
setenv OMPI_MCA_mpi_warn_on_fork 0  
hostname

# In DT1
set chm = "/lustre/home/jbklauda/charmm/c39a2wxw/myc39a2/exec/gnu_M/gfortcol.om"

# In DT2
#set chm = "/lustre/xzhuang/software/charmm/c39a2/gnu_M/gfortcol.om"

# INVOKE CHARMM
set i = $1
while ($i <= $2)
  $chm f=$i p=$3 < coord-o3.inp >& coord-o3.out
@ i = $i + 1
end


