#!/bin/csh
#SBATCH --ntasks=1
#SBATCH -N 1 
#SBATCH --job-name=exact
#SBATCH -t 2:00:00
#SBATCH --constraint="[ib|qib]"

unset noclobber
# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR

module load openmpi/1.6
module load fftw/3.3.3/gnu/4.6.1/openmpi/1.6/shared
setenv LD_LIBRARY_PATH $FFTWLIB  
# XZ: Turn off the mpi warning as infiniband is being used with the OFED verbs driver.
setenv OMPI_MCA_mpi_warn_on_fork 0  
hostname

# In DT1
set chm = "/lustre/home/jbklauda/charmm/c39a2wxw/myc39a2/exec/gnu_M/gfortcol.om"

# In DT2
#set chm = "/lustre/xzhuang/software/charmm/c39a2/gnu_M/gfortcol.om"

# generate crd file
$chm p=$3 < gen_crd.inp >& gen_crd.out

# Loop over all trajectories and extract the x-dimension size
# Handled in submission script due to changes in traj. header info
set i = $1
while ($i <= $2)
  $chm i=$i p=$3 < extract.inp >& extract.out 
@ i = $i + 1
end


